#ifndef	_memory_object_control_user_
#define	_memory_object_control_user_

/* Module memory_object_control */

#include <string.h>
#include <mach/ndr.h>
#include <mach/boolean.h>
#include <mach/kern_return.h>
#include <mach/notify.h>
#include <mach/mach_types.h>
#include <mach/message.h>
#include <mach/mig_errors.h>
#include <mach/port.h>

#ifdef AUTOTEST
#ifndef FUNCTION_PTR_T
#define FUNCTION_PTR_T
typedef void (*function_ptr_t)(mach_port_t, char *, mach_msg_type_number_t);
typedef struct {
        char            *name;
        function_ptr_t  function;
} function_table_entry;
typedef function_table_entry 	*function_table_t;
#endif /* FUNCTION_PTR_T */
#endif /* AUTOTEST */

#ifndef	memory_object_control_MSG_COUNT
#define	memory_object_control_MSG_COUNT	16
#endif	/* memory_object_control_MSG_COUNT */

#include <mach/std_types.h>
#include <mach/mach_types.h>

#ifdef __BeforeMigUserHeader
__BeforeMigUserHeader
#endif /* __BeforeMigUserHeader */


/* Routine memory_object_get_attributes */
#ifdef	mig_external
mig_external
#else
extern
#endif	/* mig_external */
kern_return_t memory_object_get_attributes
(
	vm_object_t memory_control,
	memory_object_flavor_t flavor,
	memory_object_info_t attributes,
	mach_msg_type_number_t *attributesCnt
);

/* SimpleRoutine memory_object_change_attributes */
#ifdef	mig_external
mig_external
#else
extern
#endif	/* mig_external */
kern_return_t memory_object_change_attributes
(
	vm_object_t memory_control,
	memory_object_flavor_t flavor,
	memory_object_info_t attributes,
	mach_msg_type_number_t attributesCnt,
	mach_port_t reply_to
);

/* SimpleRoutine memory_object_synchronize_completed */
#ifdef	mig_external
mig_external
#else
extern
#endif	/* mig_external */
kern_return_t memory_object_synchronize_completed
(
	vm_object_t memory_control,
	vm_offset_t offset,
	vm_offset_t length
);

/* SimpleRoutine memory_object_data_unavailable */
#ifdef	mig_external
mig_external
#else
extern
#endif	/* mig_external */
kern_return_t memory_object_data_unavailable
(
	vm_object_t memory_control,
	vm_offset_t offset,
	vm_size_t size
);

/* SimpleRoutine memory_object_lock_request */
#ifdef	mig_external
mig_external
#else
extern
#endif	/* mig_external */
kern_return_t memory_object_lock_request
(
	vm_object_t memory_control,
	vm_offset_t offset,
	vm_size_t size,
	memory_object_return_t should_return,
	integer_t flags,
	vm_prot_t lock_value,
	mach_port_t reply_to
);

/* SimpleRoutine memory_object_data_error */
#ifdef	mig_external
mig_external
#else
extern
#endif	/* mig_external */
kern_return_t memory_object_data_error
(
	vm_object_t memory_control,
	vm_offset_t offset,
	vm_size_t size,
	kern_return_t error_value
);

/* SimpleRoutine memory_object_destroy */
#ifdef	mig_external
mig_external
#else
extern
#endif	/* mig_external */
kern_return_t memory_object_destroy
(
	vm_object_t memory_control,
	kern_return_t reason
);

/* SimpleRoutine memory_object_data_supply */
#ifdef	mig_external
mig_external
#else
extern
#endif	/* mig_external */
kern_return_t memory_object_data_supply
(
	vm_object_t memory_control,
	vm_offset_t offset,
	vm_offset_t data,
	mach_msg_type_number_t dataCnt,
	boolean_t dataDealloc,
	vm_prot_t lock_value,
	boolean_t precious,
	mach_port_t reply_to
);

/* SimpleRoutine memory_object_discard_reply */
#ifdef	mig_external
mig_external
#else
extern
#endif	/* mig_external */
kern_return_t memory_object_discard_reply
(
	vm_object_t memory_control,
	vm_offset_t requested_offset,
	vm_size_t requested_size,
	vm_offset_t discard_offset,
	vm_size_t discard_size,
	memory_object_return_t should_return,
	mach_port_t reply_to
);

/* Routine vm_object_upl_request */
#ifdef	mig_external
mig_external
#else
extern
#endif	/* mig_external */
kern_return_t vm_object_upl_request
(
	vm_object_t object,
	memory_object_offset_t offset,
	vm_size_t size,
	mach_port_t *upl,
	upl_page_list_ptr_t page_list,
	mach_msg_type_number_t *page_listCnt,
	integer_t cntrl_flags
);

/* Routine vm_pager_upl_request */
#ifdef	mig_external
mig_external
#else
extern
#endif	/* mig_external */
kern_return_t vm_pager_upl_request
(
	vm_object_t object,
	memory_object_offset_t offset,
	vm_size_t size,
	vm_size_t super_size,
	mach_port_t *upl,
	upl_page_list_ptr_t page_list,
	mach_msg_type_number_t *page_listCnt,
	integer_t cntrl_flags
);

/* Routine vm_upl_map */
#ifdef	mig_external
mig_external
#else
extern
#endif	/* mig_external */
kern_return_t vm_upl_map
(
	vm_map_t map,
	upl_object_t upl,
	vm_offset_t *dst_addr
);

/* Routine vm_upl_unmap */
#ifdef	mig_external
mig_external
#else
extern
#endif	/* mig_external */
kern_return_t vm_upl_unmap
(
	vm_map_t map,
	upl_object_t upl
);

/* Routine vm_upl_abort */
#ifdef	mig_external
mig_external
#else
extern
#endif	/* mig_external */
kern_return_t vm_upl_abort
(
	upl_t upl_object,
	integer_t abort_cond
);

/* Routine vm_upl_commit */
#ifdef	mig_external
mig_external
#else
extern
#endif	/* mig_external */
kern_return_t vm_upl_commit
(
	upl_t upl_object,
	upl_page_list_ptr_t page_list,
	mach_msg_type_number_t page_listCnt
);

/* Routine vm_upl_commit_range */
#ifdef	mig_external
mig_external
#else
extern
#endif	/* mig_external */
kern_return_t vm_upl_commit_range
(
	upl_t upl_object,
	vm_offset_t offset,
	vm_size_t size,
	upl_page_list_ptr_t page_list,
	mach_msg_type_number_t page_listCnt
);

#ifndef subsystem_to_name_map_memory_object_control
#define subsystem_to_name_map_memory_object_control \
    { "memory_object_get_attributes", 2000 },\
    { "memory_object_change_attributes", 2001 },\
    { "memory_object_synchronize_completed", 2002 },\
    { "memory_object_data_unavailable", 2003 },\
    { "memory_object_lock_request", 2004 },\
    { "memory_object_data_error", 2005 },\
    { "memory_object_destroy", 2006 },\
    { "memory_object_data_supply", 2007 },\
    { "memory_object_discard_reply", 2008 },\
    { "vm_object_upl_request", 2009 },\
    { "vm_pager_upl_request", 2010 },\
    { "vm_upl_map", 2011 },\
    { "vm_upl_unmap", 2012 },\
    { "vm_upl_abort", 2013 },\
    { "vm_upl_commit", 2014 },\
    { "vm_upl_commit_range", 2015 }
#endif

#ifdef __AfterMigUserHeader
__AfterMigUserHeader
#endif /* __AfterMigUserHeader */

#endif	 /* _memory_object_control_user_ */
